#include "TcpComLink.h"
#include <winsock2.h>

//static local variables
struct TcpComLink
{
    SOCKET Socket;
};

TcpComLink* TcpComLink_Create(int socket)
{
	TcpComLink* self = (TcpComLink*)malloc(sizeof(TcpComLink));
	memset(self, 0, sizeof(TcpComLink));
	self->Socket = socket;
	return self;
}

void TcpComLink_Destroy(TcpComLink* self)
{
    free(self);
}

int TcpComLink_send(void * voidSelf, char * msg, int length)
{
	TcpComLink * self = (TcpComLink *)voidSelf;
    int total = 0;        // how many bytes we've sent
    int bytesleft = length; // how many we have left to send
    int n;

    while(total < length) {
        n = send(self->Socket, msg+total, bytesleft, 0);
        if (n == -1) { break; }
        total += n;
        bytesleft -= n;
    }

    return total;
} 

int TcpComLink_recv(void * voidSelf, char * buffer, int length)
{
	TcpComLink * self = (TcpComLink *)voidSelf;

	//No MSG_WAITALL flag in winsock2 ????
	int bytesReceived = 0;
	while (bytesReceived < length)
	{
		bytesReceived += recv(self->Socket, buffer + bytesReceived, length - bytesReceived, 0);
	}
	return bytesReceived;
}
